Package org.optaplanner.core.api.score.buildin.hardmediumsoftlong

## Class HardMediumSoftLongScore

- java.lang.Object
- - org.optaplanner.core.api.score.AbstractScore<HardMediumSoftLongScore>
  - - org.optaplanner.core.api.score.buildin.hardmediumsoftlong.HardMediumSoftLongScore

- All Implemented Interfaces:
    `Serializable`, `Comparable<HardMediumSoftLongScore>`, `FeasibilityScore<HardMediumSoftLongScore>`, `Score<HardMediumSoftLongScore>`

      public final class HardMediumSoftLongScore
      extends AbstractScore<HardMediumSoftLongScore>
      implements FeasibilityScore<HardMediumSoftLongScore>

  This `Score` is based on 3 levels of long constraints: hard, medium and soft. Hard constraints have priority over medium constraints. Medium constraints have priority over soft constraints. Hard constraints determine feasibility.

  This class is immutable.

  See Also:
    `Score`, Serialized Form

- - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `static HardMediumSoftLongScore` | `ONE_HARD` |
    `static HardMediumSoftLongScore` | `ONE_MEDIUM` |
    `static HardMediumSoftLongScore` | `ONE_SOFT` |
    `static HardMediumSoftLongScore` | `ZERO` |

    - ### Fields inherited from class org.optaplanner.core.api.score.AbstractScore

      `INIT_LABEL, initScore`

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods Deprecated Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `HardMediumSoftLongScore` | `add​(HardMediumSoftLongScore addend)` | Returns a Score whose value is (this + addend).
    `int` | `compareTo​(HardMediumSoftLongScore other)` |
    `HardMediumSoftLongScore` | `divide​(double divisor)` | Returns a Score whose value is (this / divisor).
    `boolean` | `equals​(Object o)` |
    `long` | `getHardScore()` | The total of the broken negative hard constraints and fulfilled positive hard constraints.
    `long` | `getMediumScore()` | The total of the broken negative medium constraints and fulfilled positive medium constraints.
    `long` | `getSoftScore()` | The total of the broken negative soft constraints and fulfilled positive soft constraints.
    `int` | `hashCode()` |
    `boolean` | `isCompatibleArithmeticArgument​(Score otherScore)` |
    `boolean` | `isFeasible()` | A `PlanningSolution` is feasible if it has no broken hard constraints.
    `HardMediumSoftLongScore` | `multiply​(double multiplicand)` | Returns a Score whose value is (this * multiplicand).
    `HardMediumSoftLongScore` | `negate()` | Returns a Score whose value is (- this).
    `static HardMediumSoftLongScore` | `of​(long hardScore, long mediumScore, long softScore)` |
    `static HardMediumSoftLongScore` | `ofHard​(long hardScore)` |
    `static HardMediumSoftLongScore` | `ofMedium​(long mediumScore)` |
    `static HardMediumSoftLongScore` | `ofSoft​(long softScore)` |
    `static HardMediumSoftLongScore` | `ofUninitialized​(int initScore, long hardScore, long mediumScore, long softScore)` |
    `static HardMediumSoftLongScore` | `parseScore​(String scoreString)` |
    `HardMediumSoftLongScore` | `power​(double exponent)` | Returns a Score whose value is (this ^ exponent).
    `HardMediumSoftLongScore` | `subtract​(HardMediumSoftLongScore subtrahend)` | Returns a Score whose value is (this - subtrahend).
    `Number[]` | `toLevelNumbers()` | Returns an array of numbers representing the Score.
    `String` | `toShortString()` | Like `Object.toString()`, but trims score levels which have a zero weight.
    `String` | `toString()` |
    `static HardMediumSoftLongScore` | `valueOf​(long hardScore, long mediumScore, long softScore)` | Deprecated. in favor of `of(long, long, long)`
    `static HardMediumSoftLongScore` | `valueOfUninitialized​(int initScore, long hardScore, long mediumScore, long softScore)` | Deprecated. in favor of `ofUninitialized(int, long, long, long)`
    `HardMediumSoftLongScore` | `withInitScore​(int newInitScore)` | For example `0hard/-8soft` with `-7` returns `-7init/0hard/-8soft`.

    - ### Methods inherited from class org.optaplanner.core.api.score.AbstractScore

      `assertNoInitScore, buildScorePattern, buildShortString, getInitPrefix, getInitScore, isSolutionInitialized, parseInitScore, parseLevelAsBigDecimal, parseLevelAsDouble, parseLevelAsInt, parseLevelAsLong, parseScoreTokens`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface org.optaplanner.core.api.score.Score

      `getInitScore, isSolutionInitialized, toInitializedScore`

- - ### Field Detail

    - #### ZERO

          public static final HardMediumSoftLongScore ZERO

    - #### ONE_HARD

          public static final HardMediumSoftLongScore ONE_HARD

    - #### ONE_MEDIUM

          public static final HardMediumSoftLongScore ONE_MEDIUM

    - #### ONE_SOFT

          public static final HardMediumSoftLongScore ONE_SOFT

  - ### Method Detail

    - #### parseScore

          public static HardMediumSoftLongScore parseScore​(String scoreString)

    - #### ofUninitialized

          public static HardMediumSoftLongScore ofUninitialized​(int initScore,
                                                                long hardScore,
                                                                long mediumScore,
                                                                long softScore)

    - #### valueOfUninitialized

          @Deprecated
          public static HardMediumSoftLongScore valueOfUninitialized​(int initScore,
                                                                     long hardScore,
                                                                     long mediumScore,
                                                                     long softScore)

      Deprecated.
      in favor of `ofUninitialized(int, long, long, long)`

    - #### of

          public static HardMediumSoftLongScore of​(long hardScore,
                                                   long mediumScore,
                                                   long softScore)

    - #### valueOf

          @Deprecated
          public static HardMediumSoftLongScore valueOf​(long hardScore,
                                                        long mediumScore,
                                                        long softScore)

      Deprecated.
      in favor of `of(long, long, long)`

    - #### ofHard

          public static HardMediumSoftLongScore ofHard​(long hardScore)

    - #### ofMedium

          public static HardMediumSoftLongScore ofMedium​(long mediumScore)

    - #### ofSoft

          public static HardMediumSoftLongScore ofSoft​(long softScore)

    - #### getHardScore

          public long getHardScore()

      The total of the broken negative hard constraints and fulfilled positive hard constraints. Their weight is included in the total. The hard score is usually a negative number because most use cases only have negative constraints.
      Returns:
        higher is better, usually negative, 0 if no hard constraints are broken/fulfilled

    - #### getMediumScore

          public long getMediumScore()

      The total of the broken negative medium constraints and fulfilled positive medium constraints. Their weight is included in the total. The medium score is usually a negative number because most use cases only have negative constraints.

      In a normal score comparison, the medium score is irrelevant if the 2 scores don't have the same hard score.

      Returns:
        higher is better, usually negative, 0 if no medium constraints are broken/fulfilled

    - #### getSoftScore

          public long getSoftScore()

      The total of the broken negative soft constraints and fulfilled positive soft constraints. Their weight is included in the total. The soft score is usually a negative number because most use cases only have negative constraints.

      In a normal score comparison, the soft score is irrelevant if the 2 scores don't have the same hard and medium score.

      Returns:
        higher is better, usually negative, 0 if no soft constraints are broken/fulfilled

    - #### withInitScore

          public HardMediumSoftLongScore withInitScore​(int newInitScore)

      Description copied from interface: `Score`
      For example `0hard/-8soft` with `-7` returns `-7init/0hard/-8soft`.
      Specified by:
        `withInitScore` in interface `Score<HardMediumSoftLongScore>`
      Parameters:
        `newInitScore` - always negative (except in statistical calculations), 0 if all planning variables are initialized
      Returns:
        equals score except that `Score.getInitScore()` is set to `newInitScore`

    - #### isFeasible

          public boolean isFeasible()

      A `PlanningSolution` is feasible if it has no broken hard constraints.
      Specified by:
        `isFeasible` in interface `FeasibilityScore<HardMediumSoftLongScore>`
      Specified by:
        `isFeasible` in interface `Score<HardMediumSoftLongScore>`
      Returns:
        true if the `getHardScore()` is 0 or higher

    - #### add

          public HardMediumSoftLongScore add​(HardMediumSoftLongScore addend)

      Description copied from interface: `Score`
      Returns a Score whose value is (this + addend).
      Specified by:
        `add` in interface `Score<HardMediumSoftLongScore>`
      Parameters:
        `addend` - value to be added to this Score
      Returns:
        this + addend

    - #### subtract

          public HardMediumSoftLongScore subtract​(HardMediumSoftLongScore subtrahend)

      Description copied from interface: `Score`
      Returns a Score whose value is (this - subtrahend).
      Specified by:
        `subtract` in interface `Score<HardMediumSoftLongScore>`
      Parameters:
        `subtrahend` - value to be subtracted from this Score
      Returns:
        this - subtrahend, rounded as necessary

    - #### multiply

          public HardMediumSoftLongScore multiply​(double multiplicand)

      Description copied from interface: `Score`
      Returns a Score whose value is (this * multiplicand). When rounding is needed, it should be floored (as defined by `Math.floor(double)`).

      If the implementation has a scale/precision, then the unspecified scale/precision of the double multiplicand should have no impact on the returned scale/precision.

      Specified by:
        `multiply` in interface `Score<HardMediumSoftLongScore>`
      Parameters:
        `multiplicand` - value to be multiplied by this Score.
      Returns:
        this * multiplicand

    - #### divide

          public HardMediumSoftLongScore divide​(double divisor)

      Description copied from interface: `Score`
      Returns a Score whose value is (this / divisor). When rounding is needed, it should be floored (as defined by `Math.floor(double)`).

      If the implementation has a scale/precision, then the unspecified scale/precision of the double divisor should have no impact on the returned scale/precision.

      Specified by:
        `divide` in interface `Score<HardMediumSoftLongScore>`
      Parameters:
        `divisor` - value by which this Score is to be divided
      Returns:
        this / divisor

    - #### power

          public HardMediumSoftLongScore power​(double exponent)

      Description copied from interface: `Score`
      Returns a Score whose value is (this ^ exponent). When rounding is needed, it should be floored (as defined by `Math.floor(double)`).

      If the implementation has a scale/precision, then the unspecified scale/precision of the double exponent should have no impact on the returned scale/precision.

      Specified by:
        `power` in interface `Score<HardMediumSoftLongScore>`
      Parameters:
        `exponent` - value by which this Score is to be powered
      Returns:
        this ^ exponent

    - #### negate

          public HardMediumSoftLongScore negate()

      Description copied from interface: `Score`
      Returns a Score whose value is (- this).
      Specified by:
        `negate` in interface `Score<HardMediumSoftLongScore>`
      Returns:
        - this

    - #### toLevelNumbers

          public Number[] toLevelNumbers()

      Description copied from interface: `Score`
      Returns an array of numbers representing the Score. Each number represents 1 score level. A greater score level uses a lower array index than a lesser score level.

      When rounding is needed, each rounding should be floored (as defined by `Math.floor(double)`). The length of the returned array must be stable for a specific `Score` implementation.

      For example: `-0hard/-7soft` returns `new int{-0, -7}`

      The level numbers do not contain the `Score.getInitScore()`. For example: `-3init/-0hard/-7soft` also returns `new int{-0, -7}`

      Specified by:
        `toLevelNumbers` in interface `Score<HardMediumSoftLongScore>`
      Returns:
        never null
      See Also:
        `ScoreDefinition.fromLevelNumbers(int, Number[])`

    - #### equals

          public boolean equals​(Object o)

      Overrides:
        `equals` in class `Object`

    - #### hashCode

          public int hashCode()

      Overrides:
        `hashCode` in class `Object`

    - #### compareTo

          public int compareTo​(HardMediumSoftLongScore other)

      Specified by:
        `compareTo` in interface `Comparable<HardMediumSoftLongScore>`

    - #### toShortString

          public String toShortString()

      Description copied from interface: `Score`
      Like `Object.toString()`, but trims score levels which have a zero weight. For example 0hard/-258soft returns -258soft.

      Do not use this format to persist information as text, use `Object.toString()` instead, so it can be parsed reliably.

      Specified by:
        `toShortString` in interface `Score<HardMediumSoftLongScore>`
      Returns:
        never null

    - #### toString

          public String toString()

      Overrides:
        `toString` in class `Object`

    - #### isCompatibleArithmeticArgument

          public boolean isCompatibleArithmeticArgument​(Score otherScore)

      Specified by:
        `isCompatibleArithmeticArgument` in interface `Score<HardMediumSoftLongScore>`
      Parameters:
        `otherScore` - never null
      Returns:
        true if the otherScore is accepted as a parameter of `Score.add(Score)`, `Score.subtract(Score)` and `Comparable.compareTo(Object)`.